#ifndef ACCUMULATIVE_TIMER_H__
#define ACCUMULATIVE_TIMER_H__

#include "Timer.h"

// A timer that can accumulates the elapsed time between calls to its Start()
// and Stop() functions.
class AccumulativeTimer : public Timer {
public:
    AccumulativeTimer();
    virtual ~AccumulativeTimer() {};

    // Stops the timer and accumulates the elapsed time from the last call to
    // Start().
    void Stop() override;
    // Resets the timer.
    void Reset();
};

#endif