#ifndef IK_SOLVER_H__
#define IK_SOLVER_H__

#include "EffectorCollection.h"
#include "Common.h"

/* An IKSolver manages effectors, targets, and solves IK for a tree */
class IKSolver {
public:
    enum Method {
        DLS,
        SDLS
    };

    DUMMY_DEFAULT_CONSTRUCTOR_AND_DESTRUCTOR(IKSolver)

    IKSolver(Tree* tree, EffectorCollection* effectors);

    virtual void Solve(Tree* tree, EffectorCollection* effectors,
                       int iterationCount = kDefaultIterationCount_) = 0;

protected:
    float maxAngleChange_;
    static const int kDefaultIterationCount_ = 1;
    static const float kDefaultMaxAngleChange_;
};

#endif    // IK_SOLVER_H__