#ifndef IK_SOLVER_DSL_H__
#define IK_SOLVER_DSL_H__

#include "IKSolverJacobian.h"

/*
 * An IK solver that uses the DLS method
 */
class IKSolverDLS : public IKSolverJacobian {
public:
    DUMMY_DEFAULT_CONSTRUCTOR_AND_DESTRUCTOR(IKSolverDLS)

    IKSolverDLS(Tree* tree, EffectorCollection *effectors,
                float lambda = kDefaultLambda_);

    float GetLambda() const;
    void SetLambda(float newLambda);

protected:
    static const float kDefaultLambda_;

    float lambda_;

    void ComputeDeltaTheta() override;
};

#endif    // IK_SOLVER_DLS_H__