#ifndef PROGRAM_H__
#define PROGRAM_H__

#include <string>
#include <GLEW/glew.h>
#include <AntTweakBar/AntTweakBar.h>
#include "Common.h"
#include "Renderer.h"
#include "Camera3D.h"

typedef struct Data
{
    Camera3D* camera_;
    TwBar* bar_;
} Data;

// A program is an experiment/test that we want to run.
class Program {
public:
    DUMMY_DEFAULT_CONSTRUCTOR_AND_DESTRUCTOR(Program)

    Program(Data* data);

    virtual void BeginFrame() = 0;
    virtual void Update(float time) = 0;
    virtual void Draw() = 0;

    virtual Renderer* GetRenderer() = 0;

    int GetUpdateFrequency() const;
    void SetUpdateFrequency(int updateFreq);

protected:
    static const int kDefaultUpdateFrequency_ = 60;

    std::string name_;
    std::string description_;
    int updateFrequency_;
    Data* data_;
};

#endif    // PROGRAM_H__