#ifndef IK_PROGRAM_1_
#define IK_PROGRAM_1_

#include "../IKProgram.h"

class IKProgram1 : public IKProgram
{
public:
    /*
     * Default constructor
     */
    IKProgram1();

    /*
     * Creates an IK program with the specified name
     */
    IKProgram1(const std::string &name, std::shared_ptr<IKRenderer> renderer,
        int stepsPerSecond = kDefaultUpdateStepsPerSecond_, int fps = kDefaultDrawStepsPerSecond_);

    /*
     * Updates the program's state
     * To be called each animation frame
     */
    void Update(float time) override;

    /*
     * Draws the scene
     * To be called each rendering frame
     */
    void Draw() const override;

    /*
     * Destructor
     */
    virtual ~IKProgram1();
};

#endif