#ifndef TIMER_H__
#define TIMER_H__

#include "Common.h"

// A timer keeps track of the elapsed time between two consecutive calls to
// Start() and Stop().
class Timer
{
public:
    DUMMY_DEFAULT_CONSTRUCTOR_AND_DESTRUCTOR(Timer);

    // Starts the timer.
    virtual void Start();
    // Stops the timer and records the elapsed time.
    virtual void Stop();

    // Returns the last recorded elapsed time, in seconds.
    double GetElapsedTime() const;

protected:
    // The time at the last call to Start(), in seconds.
    double startTime_;
    // The time at the last call to Stop(), in seconds.
    double stopTime_;
    // The elapsed time from the last call to Start() to the last call to
    // Stop(), in seconds.
    double elapsedTime_;
};

#endif    // TIMER_H__